package net.roseindia.web.ui;
import net.roseindia.web.common.*;

import net.roseindia.dao.*;

import java.util.*;
import java.util.regex.*;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;

public class Bean{
	String userName;
	String pwd;
	String confPwd;
	String email;
	String address;
	boolean exist=false;
				
	public void setUserName(String userName){
		this.userName=userName;
	}
	public void setPwd(String pwd){
		this.pwd=pwd;
	}
	public void setConfPwd(String confPwd){
		this.confPwd=confPwd;
	}
	public void setEmail(String email){
		this.email=email;
	}
	public void setAddress(String address){
		this.address=address;
	}
	public void setExist(boolean exist){
		this.exist=exist;
	}


	public String getUserName(){
		return userName;
	}
	public String getPwd(){
		return pwd;
	}
	public String getConfPwd(){
		return confPwd;
	}
	public String getEmail(){
		return email;
	}
	public String getAddress(){
		return address;
	}
	public boolean getExist(){
		return exist;
	}
	


public String register() throws Exception {
    String status = "failure";
    if (validateData()) {  
		HibernateSpringDAO dao =(HibernateSpringDAO)ServiceFinder.findBean("SpringHibernateDao");

		if(dao.checkUser(getUserName())!=null){
			exist=true;
			status = "failure";
		}else{

			net.roseindia.dao.hibernate.User user = new net.roseindia.dao.hibernate.User();

			//Set user name
			user.setUserName(getUserName());


			//Set user Password
			user.setUserPassword(getPwd());

			//Set user Email
			user.setUserEmail(getEmail());

			//Set Address
			user.setUserAddress(getAddress());


			dao.addUser(user);
				status = "success";
		}
        

	}
    return status;
  }

private boolean validateData() {
    boolean status = true;
    MessageFactory mf = new MessageFactory();
    FacesContext ctx = FacesContext.getCurrentInstance();

//Checking User Name
if((userName.length())<4   ){
	ctx.addMessage("registerForm:userName", 
          new FacesMessage(FacesMessage.SEVERITY_ERROR, mf.getMessage("errorUserName"), null));
	      status = false;
	}
// End of checking User Name

//Checking of Password Length
if((pwd.length())<6   ){
	ctx.addMessage("registerForm:Password", 
          new FacesMessage(FacesMessage.SEVERITY_ERROR, mf.getMessage("errorPasswordLength"), null));
	      status = false;
	}

if((confPwd.length())<6   ){
	ctx.addMessage("registerForm:confirmPassword", 
          new FacesMessage(FacesMessage.SEVERITY_ERROR, mf.getMessage("errorPasswordLength"), null));
	      status = false;
	}
// End of checking Password Length

//Checking passwords
    if (!confPwd.equals(pwd)) {
      ctx.addMessage("registerForm:confirmPassword", 
          new FacesMessage(FacesMessage.SEVERITY_ERROR, mf.getMessage("errorPasswordConfirm"), null));
	      status = false;
	}
//End of checking passwords

//Checking Email address
	Pattern p = Pattern.compile(".+@.+\\.[a-z]+");
	Matcher m = p.matcher(email);
	boolean matchFound = m.matches();

	if (!matchFound) {
		ctx.addMessage("registerForm:email", 
        new FacesMessage(FacesMessage.SEVERITY_ERROR, mf.getMessage("errorEmail"), null));
	    status = false;
	}
// End of checking Email address


    return status;
  }
		
}


